

import sys, getopt
import csv

def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        return False


#gets the type of each column in a file with header
def getType_h(ifile, MAX_ENUMERATED = 3):
    fileIn = open(ifile)
    #get names of attributes
    attrs = fileIn.readline().strip().split(',') 
    nattrs = len(attrs)
    atype = [True] *  nattrs
    
    distinctValues = []
    for k in range(nattrs):
        distinctValues.append(set())
    
    #get types analyzing the others lines
    lines = csv.reader(fileIn, delimiter = ',')
    for row in lines:
        #for each column
        for k in range(nattrs):
            if row[k] == '?':
                pass
            else:
                atype[k] = atype[k] & is_number(row[k])
                if len(distinctValues[k]) <= MAX_ENUMERATED:
                    distinctValues[k].add(row[k])
    fileIn.close  
    
    finalTypes = []
    for k in range(nattrs):
        if len(distinctValues[k]) > MAX_ENUMERATED:
            if atype[k] == True:
                finalTypes.append('numeric')
            else: 
                finalTypes.append('string')
        else:
            #enumerated - construct string
            res = "{"
            first = True
            for s in distinctValues[k]:
                if first:
                    first = False
                else:
                    res += ","
                res += s
            res += "}"  
            finalTypes.append(res)
    return attrs, finalTypes


#gets the type of each column in a file without header
def getType(ifile,MAX_ENUMERATED = 3):
    
    fileIn = open(ifile)
    
    lines = csv.reader(fileIn, delimiter = ',')
    
    distinctValues = []
    atype = []
    nattrs = 0
    first_line = True
    
    for row in lines:
        if first_line:
            #Initialize data structures 
            nattrs = len(row)
            atype = [True] *  nattrs
            for k in range(nattrs):
                distinctValues.append(set())
            first_line = False
            
        for k in range(nattrs):
            if row[k] == '?':
                pass
            else:
                atype[k] = atype[k] & is_number(row[k])
                if len(distinctValues[k]) <= MAX_ENUMERATED:
                    distinctValues[k].add(row[k])
    fileIn.close   
    
    finalTypes = []
    for k in range(nattrs):
        if len(distinctValues[k]) > MAX_ENUMERATED:
            if atype[k] == True:
                finalTypes.append('numeric')
            else: 
                finalTypes.append('string')
        else:
            #enumerated - construct string
            res = "{"
            first = True
            for s in distinctValues[k]:
                if first:
                    first = False
                else:
                    res += ","
                res += s
            res += "}"  
            finalTypes.append(res)     
    return finalTypes



def csv2arff(ifile, ofile, maxenum):    
    fileOut = open(ofile,"w")
    fileOut.write("@RELATION "+ofile+"\n")
    #get types of attributes
    attTypes = getType(ifile, MAX_ENUMERATED = maxenum)
    #write metadata
    for k in range(len(attTypes)):   
        fileOut.write("@ATTRIBUTE column-"+ str(k) +" "+ attTypes[k] +"\n")
    #write data
    fileOut.write("@DATA \n");
    fileIn = open(ifile);
    fileOut.writelines(fileIn.readlines())
    fileIn.close()
    fileOut.close()

def csv2arff_h(ifile, ofile,maxenum):

    fileOut = open(ofile,"w")
    fileOut.write("@RELATION "+ofile+"\n")
   
    #get types of attributes and their names
    attrs, attTypes = getType_h(ifile, MAX_ENUMERATED = maxenum)
    #write metadata
    for k in range(len(attTypes)):   
        fileOut.write("@ATTRIBUTE "+ attrs[k]+" "+ attTypes[k] +"\n")
    
    #write data    
    fileOut.write("@DATA \n");
    fileIn = open(ifile);
    fileIn.readline()
    fileOut.writelines(fileIn.readlines())
    fileIn.close()
    fileOut.close()
 
    
    
#------ MAIN PROGRAM ------------------------------------------------------------------
    
# Store input and output file names
ifile=''
ofile=''
# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:h:m:")
###############################
# o == option
# a == argument passed to the o
###############################
for o, a in myopts:
    if o == '-i':
        ifile=a
    elif o == '-o':
        ofile=a
    elif o == '-h':
        head=a
    elif o == '-m':
        maxenum=a
    else:
        print("Usage: %s -i input -o output -h y/n" % sys.argv[0])

if head == 'y':
    csv2arff_h(ifile,ofile,maxenum)
else:
    csv2arff(ifile,ofile,maxenum)
